// Application class implementation
#include "pch.h"
#include "Application.h"
#include "resources.h"

// Enable visual styles
#pragma comment(linker, "\"/manifestdependency:type='win32' \
name='Microsoft.Windows.Common-Controls' version='6.0.0.0' \
processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")

namespace mainspring {
    Application::Application(const char* appName, const char* appVersion)
        : m_appName(appName)
        , m_appVersion(appVersion)
    {
        std::cout << std::format("{} {}\n", m_appName, m_appVersion);
    }

    void Application::run() {
        DialogBoxParam(nullptr, MAKEINTRESOURCE(IDD_DIALOGMAIN), nullptr, reinterpret_cast<DLGPROC>(mainDlgProc), reinterpret_cast<LPARAM>(this));
    }

    BOOL CALLBACK Application::mainDlgProc(HWND dlg, UINT msg, WPARAM wParam, LPARAM lParam) {
        static Application* app = nullptr;

        switch (msg) {
            case WM_INITDIALOG: {
                app = reinterpret_cast<Application*>(lParam);

                SetWindowText(dlg, app->m_appName);

                POINT cursor = {};
                GetCursorPos(&cursor);
                MONITORINFO mi = {};
                mi.cbSize = sizeof(mi);
                GetMonitorInfo(MonitorFromPoint(cursor, MONITOR_DEFAULTTONEAREST), &mi);
                SetWindowPos(dlg, nullptr, mi.rcMonitor.left + 100, mi.rcMonitor.top + 100, 0, 0, SWP_NOZORDER | SWP_NOSIZE);

                SetDlgItemText(dlg, IDC_STATICTITLE, app->m_appName);
                LOGFONT lFont = {};
                lFont.lfHeight = 30;
                HFONT titleFont = CreateFontIndirect(&lFont);
                SendMessage(GetDlgItem(dlg, IDC_STATICTITLE), WM_SETFONT, reinterpret_cast<WPARAM>(titleFont), NULL);

                lFont.lfHeight = 40;
                HFONT timeFont = CreateFontIndirect(&lFont);
                SendMessage(GetDlgItem(dlg, IDC_STATICTIME), WM_SETFONT, reinterpret_cast<WPARAM>(timeFont), NULL);

                SetDlgItemText(dlg, IDC_BUTTONSTARTPAUSE, "Start");

                return TRUE;
            }

            case WM_CLOSE:
                EndDialog(dlg, 0);
                return TRUE;
        }

        return FALSE;
    }

    Application::~Application() {

    }
}